var _createClass = function() {
    function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) descriptor.writable = true;
            Object.defineProperty(target, descriptor.key, descriptor);
        }
    }
    return function(Constructor, protoProps, staticProps) {
        if (protoProps) defineProperties(Constructor.prototype, protoProps);
        if (staticProps) defineProperties(Constructor, staticProps);
        return Constructor;
    };
}();

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}

/**
 * @author ForeverZi
 * @email txzm2018@gmail.com
 * @create date 2019-01-18 21:38:55
 * @modify date 2019-01-18 21:38:55
 * @desc [description]
 */ var Cache = function() {
    function Cache(destroyFunc) {
        _classCallCheck(this, Cache);
        this._pool = {};
        // 销毁值的方法
                this._destroyFunc = destroyFunc;
        this._id = 0;
    }
    _createClass(Cache, [ {
        key: "get",
        value: function get(key) {
            return this._pool[key];
        }
    }, {
        key: "put",
        value: function put(key, value) {
            // 如果之前的缓存中存在值，则先销毁
            this.delete(key);
            this._pool[key] = value;
        }
    }, {
        key: "add",
        value: function add(value) {
            this.delete(this._id);
            this._pool[this._id] = value;
            this._id++;
            return this._id - 1;
        }
    }, {
        key: "delete",
        value: function _delete(key) {
            if (!this._pool[key]) {
                return;
            }
            if (typeof this._destroyFunc === "function") {
                this._destroyFunc(this._pool[key]);
            }
            delete this._pool[key];
        }
    }, {
        key: "clear",
        value: function clear() {
            var _this = this;
            if (typeof this._destroyFunc === "function") {
                var keys = Object.keys(this._pool);
                keys.forEach(function(key) {
                    return _this.delete(key);
                });
            }
            this._pool = {};
        }
    } ]);
    return Cache;
}();

module.exports = Cache;