var _createClass = function() {
    function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) descriptor.writable = true;
            Object.defineProperty(target, descriptor.key, descriptor);
        }
    }
    return function(Constructor, protoProps, staticProps) {
        if (protoProps) defineProperties(Constructor.prototype, protoProps);
        if (staticProps) defineProperties(Constructor, staticProps);
        return Constructor;
    };
}();

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}

/**
 * @author ForeverZi
 * @create date 2019-01-21 02:36:31
 * @modify date 2019-01-21 02:36:31
 * @desc [description]
 */ var Item = require("./Item");

var Cache = require("./Cache");

var imgCache = new Cache(function(img) {
    return img = null;
});

var canvasCache = new Cache(function(canv) {
    return canv = null;
});

var SYS_INFO = wx.getSystemInfoSync();

var RES_DIR = "";

var ITEM_BG_PATH = [ "ui/rank/bg_rank_1.png", "ui/rank/bg_rank_2.png", "ui/rank/bg_rank_me.png", "ui/rank/cell_rank_1.png", "ui/rank/cell_rank_0.png", "ui/rank/avater_default.png", "ui/rank/tag_rank_over.png", "ui/rank/tag_rank_over_0.png", "ui/rank/bg_mask.png", "ui/rank/icon_first.png", "ui/rank/cell_rank_2.png" ];

//设计分辨率
var BG_HEIGHT = 8;

var BG_WIDTH = 8;

var DESIGE_WIDTH = 750;

var DESIGE_HEIGHT = DESIGE_WIDTH * (SYS_INFO.screenHeight / SYS_INFO.screenWidth);

var SCREEN_OFFSET_TOP = SYS_INFO.screenHeight - 1334 * (SYS_INFO.screenWidth / DESIGE_WIDTH);

//LIST好友/群列表,ITEM列表元素
var SCROLL_BRAKE = .06;

//滚动之后的减速系数
var LIST_TOP = 10;

var LIST_LEFT = 20;

var LIST_HEIGHT = 690;

var LIST_WIDTH = 558;

var ITEM_WIDTH = 558;

var ITEM_HEIGHT = 82;

var ITEM_TOP = 0;

var ITEM_BOTTOM = 10;

var ITEM_SPACINGY = 18;

var ME_OFFSET_TOP = 42;

//小排行
var LITE_TOP = 321 + SCREEN_OFFSET_TOP;

var LITE_LEFT = 103;

var LITE_WIDTH = 180;

var LITE_HEIGHT = 194;

//超越还有
var OVER_TOP = 206 + SCREEN_OFFSET_TOP;

var OVER_LEFT = 0;

var OVER_WIDTH = 750;

var OVER_HEIGHT = 112;

//复活页超越好友
var overCfg = {
    y: 161,
    x: 0,
    top: 18,
    bottom: 0,
    left: 385,
    width: 750,
    height: 92,
    spaceY: 0,
    spaceX: 7,
    cellSize: {
        width: 50,
        height: 50
    }
};

var RankListRenderer = function() {
    function RankListRenderer(width, height) {
        _classCallCheck(this, RankListRenderer);
        this.width = width;
        this.height = height;
        this.ctx = null;
        this.meData = null;
        this.userAvatar = null;
        this.userRank = -1;
        //总排名
                this.userScore = -1;
        //游戏最高分
                this.overScore = 0;
        //本次游戏分数
                this.overRank = 0;
        //本次游戏排名
                this.overFriend = null;
        //被超越的好友
                this.overAvatarUrl = null;
    }
    _createClass(RankListRenderer, [ {
        key: "showFriendRank",
        value: function showFriendRank() {
            this.startY = ITEM_TOP;
            this.deltaY = this.startY;
            this.items = [];
            this.fpsStartTime = null;
            this.fpsDeltaTimer = 0;
            this.moveRange = 0;
            this.moveSpeed = null;
            this.refreshRank();
            this.startRender();
        }
    }, {
        key: "showLiteRank",
        value: function showLiteRank() {
            this.lites = [];
            this.refreshRank();
        }
    }, {
        key: "showOverRank",
        value: function showOverRank() {
            this.overs = [];
            this.refreshRank();
        }
    }, {
        key: "showLoopRank",
        value: function showLoopRank() {
            this.refreshRank();
        }
    }, {
        key: "initCanvas",
        value: function initCanvas() {
            this.sharedCanvas = wx.getSharedCanvas();
            this.ctx = this.sharedCanvas.getContext("2d");
            this.ctx.imageSmoothingEnabled = true;
            this.ctx.imageSmoothingQuality = "high";
        }
    }, {
        key: "listen",
        value: function listen() {
            var _this = this;
            var self = this;
            self.initCanvas();
            wx.onMessage(function(data) {
                if (data.cmd && !data.cmd.startsWith("touch")) {
                    //console.log("主域消息：", data);
                    switch (data.cmd) {
                      case "submit_scroe":
                        self.refreshScroe(data.score);
                        break;

                      case "destroy_friend_rank":
                        self.destroy();
                        break;

                      case "open_friend_rank":
                        self.friendRankActive = true;
                        self.liteRankActive = false;
                        self.overRankActive = false;
                        self.loopRankActive = false;
                        self.showFriendRank();
                        break;

                      case "close_friend_rank":
                        self.friendRankActive = false;
                        self.hideFriendRank();
                        break;

                      case "open_lite_rank":
                        self.liteRankActive = true;
                        self.friendRankActive = false;
                        self.overRankActive = false;
                        self.loopRankActive = false;
                        self.showLiteRank();
                        break;

                      case "close_lite_rank":
                        self.liteRankActive = false;
                        // self.hideLiteRank();
                                                break;

                      case "open_over_friend":
                        self.overRankActive = true;
                        self.friendRankActive = false;
                        self.liteRankActive = false;
                        self.loopRankActive = false;
                        self.overScore = data.score;
                        self.showOverRank();
                        break;

                      case "close_over_friend":
                        self.overRankActive = false;
                        // self.hideOverRank();
                                                break;

                      case "open_loop_friend":
                        self.loopRankActive = true;
                        self.liteRankActive = false;
                        self.friendRankActive = false;
                        self.overRankActive = false;
                        self.overScore = data.score;
                        self.showLoopRank();
                        // self.hideLoopRank();
                                                break;

                      case "close_loop_friend":
                        self.loopRankActive = false;
                        // self.hideLoopRank();
                                                break;

                      case "restart_game":
                        _this.overAvatarUrl = null;
                        break;
                    }
                } else {
                    switch (data.cmd) {
                      case "touch_start":
                        self.moveSpeed = null;
                        break;

                      case "touch_move":
                        self.scroll({
                            deltaY: data.deltaY * SYS_INFO.pixelRatio
                        });
                        break;

                      case "touch_end":
                        self.startY = self.deltaY;
                        self.moveRange = 0;
                        self.moveSpeed = data.speed;
                        break;

                      case "touch_cancel":
                        self.startY = self.deltaY;
                        self.moveRange = 0;
                        self.moveSpeed = data.speed;
                        break;
                    }
                }
            });
        }
    }, {
        key: "hideFriendRank",
        value: function hideFriendRank() {
            this.stopRender();
            this.clear();
        }
    }, {
        key: "destroy",
        value: function destroy() {
            this.hideFriendRank();
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;
            try {
                for (var _iterator = this.items[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var item = _step.value;
                    item.destroy();
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
            this.itemMe && this.itemMe.destroy();
            this.items = null;
            this.itemMe = null;
            imgCache.clear();
            canvasCache.clear();
        }
    }, {
        key: "refreshRank",
        value: function refreshRank() {
            var self = this;
            if (!self.meData) {
                wx.getUserInfo({
                    openIdList: [ "selfOpenId" ],
                    //获取自己
                    success: function success(res) {
                        self.meData = res.data[0];
                        self.getFriendRank();
                    },
                    fail: function fail(res) {
                        console.error("wx.getUserInfo fail!");
                    }
                });
            } else {
                self.getFriendRank();
            }
        }
    }, {
        key: "getFriendRank",
        value: function getFriendRank() {
            var self = this;
            wx.getFriendCloudStorage({
                keyList: [ "score" ],
                success: function success(res) {
                    var data = res.data;
                    var details = [];
                    var _iteratorNormalCompletion2 = true;
                    var _didIteratorError2 = false;
                    var _iteratorError2 = undefined;
                    try {
                        for (var _iterator2 = data[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                            var info = _step2.value;
                            var detailItem = {};
                            detailItem.avatarUrl = info.avatarUrl != "" ? info.avatarUrl : "ui/rank/avater_default.png";
                            detailItem.nickName = info.nickname != "" ? info.nickname : "神秘玩家";
                            detailItem.score = 0;
                            var list = info.KVDataList;
                            var scoreInfo = list.find(function(e) {
                                return e.key === "score";
                            });
                            if (scoreInfo && scoreInfo.value != "undefined") {
                                detailItem.score = JSON.parse(scoreInfo.value);
                                details.push(detailItem);
                            }
                        }
                    } catch (err) {
                        _didIteratorError2 = true;
                        _iteratorError2 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                _iterator2.return();
                            }
                        } finally {
                            if (_didIteratorError2) {
                                throw _iteratorError2;
                            }
                        }
                    }
                    if (details.length > 1) details.sort(function(a, b) {
                        return b.score - a.score;
                    });
                    self.createItems(details);
                    if (self.liteRankActive) self.createLites(details);
                    if (self.overRankActive || self.loopRankActive) self.createOver(details);
                    self.loadImg();
                },
                fail: function fail(err) {
                    console.log("获取排行榜失败：", err);
                }
            });
            //--以下是测试代码,测试时先注销上面的代码
            // const details2 = [];
            // for (let i = 0; i < 50; i++) {
            //     const detailItem = {};
            //     detailItem.avatarUrl = "https://wx.qlogo.cn/mmopen/vi_32/DtXoGW0dQkw6F0N26oDL8hj1f17IXpWOXHZL78bxVoNToaN2IddprEpQYwbia1KjRM22r9BBjqCDwgcFegpbEeQ/132?r=" + i;
            //     detailItem.nickName = i == 10 ? "煊文" + i : "初田" + i;
            //     detailItem.avatarUrl = i!= 10 ? detailItem.avatarUrl : "https://wx.qlogo.cn/mmopen/vi_32/GrBtBp4ng8t6ibVsdRTfVibyz4ibjP0LAgI3M9fRXwO6iaJn4qZLKMGVMzRtYzVh5rAw2iac6VsdOxicmz9w1y4ImADw/132";
            //     detailItem.score = Math.floor(Math.random()*(300-0+1) +0);
            //     details2.push(detailItem);
            // }
            // self.createItems(details2);
            // if (self.liteRankActive) self.createLites(details2);
            // if (self.overRankActive || self.loopRankActive) self.createOver(details2);
            // self.loadImg();
                }
    }, {
        key: "createOver",
        value: function createOver(list) {
            var i = 0;
            var listCount = list.length;
            //超越最后一名
                        var _overRank = listCount - 1;
            //查找当前分数的前一名
                        var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;
            try {
                for (var _iterator3 = list[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                    var info = _step3.value;
                    if (info.score < this.overScore) {
                        _overRank = i - 1;
                        break;
                    }
                    i++;
                }
                //如果即将超越的人是自己，向前提一名
                        } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }
                } finally {
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }
            if (list[_overRank] && list[_overRank].avatarUrl == this.meData.avatarUrl) {
                _overRank -= 1;
            }
            var index = _overRank > 0 ? _overRank : 0;
            if (!this.overFriend) {
                this.overFriend = new Item(list[index], OVER_WIDTH, OVER_HEIGHT);
                this.overFriend.setPosition(OVER_LEFT, OVER_TOP);
            } else {
                this.overFriend.setInfo(list[index]);
            }
            this.overRank = _overRank;
            this.overs = [];
            for (var _i = 0; _i < 3; ++_i) {
                index = _overRank - _i;
                if (list[index] && list[index].avatarUrl == this.meData.avatarUrl) {
                    index -= 1;
                }
                if (index >= 0) {
                    var overItem = new Item(list[index], overCfg.cellSize.width, overCfg.cellSize.height);
                    overItem.setPosition(overCfg.left + _i * (overCfg.spaceX + overCfg.cellSize.width), overCfg.top);
                    this.overs.push(overItem);
                }
            }
        }
        //动态排行榜
        }, {
        key: "createLites",
        value: function createLites(list) {
            var i = 0;
            var _iteratorNormalCompletion4 = true;
            var _didIteratorError4 = false;
            var _iteratorError4 = undefined;
            try {
                for (var _iterator4 = list[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                    var info = _step4.value;
                    if (info.avatarUrl == this.meData.avatarUrl) {
                        this.userRank = i;
                        break;
                    }
                    i++;
                }
            } catch (err) {
                _didIteratorError4 = true;
                _iteratorError4 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion4 && _iterator4.return) {
                        _iterator4.return();
                    }
                } finally {
                    if (_didIteratorError4) {
                        throw _iteratorError4;
                    }
                }
            }
            var listCount = list.length;
            var userRanking = this.userRank;
            this.lites = [];
            if (listCount < 2) {
                var item = new Item(list[0], LITE_WIDTH, LITE_HEIGHT);
                item.setPosition(LITE_LEFT + LITE_WIDTH, LITE_TOP);
                this.lites.push(item);
            } else {
                var last = listCount - 1;
                var left = 0;
                var center = 0;
                var right = 0;
                if (userRanking != -1) {
                    //自己排名在之中
                    left = userRanking - 1;
                    center = userRanking;
                    right = userRanking + 1;
                    //自己是最后一名
                                        if (userRanking == last) {
                        left = userRanking - 2;
                        center = userRanking - 1;
                        right = userRanking;
                        if (left < 0) {
                            left = userRanking - 1;
                            center = userRanking;
                            right = userRanking;
                        }
                    }
                    //自己第一名
                     else if (left < 0) {
                        left = userRanking;
                        center = userRanking + 1;
                        right = userRanking + 2;
                        if (right > last) {
                            left = userRanking;
                            center = userRanking + 1;
                            right = userRanking + 1;
                        }
                    }
                } else {
                    //自己未上榜
                    left = last - 2;
                    center = last - 1;
                    right = last;
                    if (left < 0) {
                        left = last - 1;
                        center = last;
                        right = last;
                    }
                }
                var posX = 0;
                var posY = 0;
                var liteData = [ left, center, right ];
                var liteCount = listCount > 2 ? 3 : listCount;
                for (var _i2 = 0; _i2 < liteCount; ++_i2) {
                    posX = liteCount > 1 ? _i2 * LITE_WIDTH : LITE_WIDTH;
                    var _item = new Item(list[liteData[_i2]], LITE_WIDTH, LITE_HEIGHT);
                    _item.setPosition(posX + LITE_LEFT, LITE_TOP);
                    this.lites.push(_item);
                }
            }
        }
    }, {
        key: "createItems",
        value: function createItems(infos) {
            this.items = [];
            this.userAvatar = [];
            this.itemMe = null;
            var i = 0;
            var _iteratorNormalCompletion5 = true;
            var _didIteratorError5 = false;
            var _iteratorError5 = undefined;
            try {
                for (var _iterator5 = infos[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                    var info = _step5.value;
                    info.bgUrl = ITEM_BG_PATH[0];
                    info.rank = i;
                    if (i < 50) {
                        var item = new Item(info, ITEM_WIDTH, ITEM_HEIGHT);
                        this.items.push(item);
                        this.userAvatar.push(info.avatarUrl);
                    }
                    if (info.avatarUrl == this.meData.avatarUrl) {
                        this.userRank = i;
                        this.userScore = info.score;
                        this.itemMe = new Item(info, ITEM_WIDTH, ITEM_HEIGHT);
                        if (i >= 50) {
                            this.userAvatar.push(info.avatarUrl);
                            break;
                        }
                    }
                    i++;
                }
            } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion5 && _iterator5.return) {
                        _iterator5.return();
                    }
                } finally {
                    if (_didIteratorError5) {
                        throw _iteratorError5;
                    }
                }
            }
            var itemsHeigth = (ITEM_HEIGHT + ITEM_SPACINGY) * this.items.length;
            this.maxDeltaY = -(itemsHeigth + ITEM_BOTTOM - LIST_HEIGHT - ITEM_SPACINGY);
        }
    }, {
        key: "drawItem",
        value: function drawItem(url) {
            // 好友排行榜
            if (this.friendRankActive) {
                //console.log("好友排行榜");
                var _iteratorNormalCompletion6 = true;
                var _didIteratorError6 = false;
                var _iteratorError6 = undefined;
                try {
                    for (var _iterator6 = this.items[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
                        var item = _step6.value;
                        item.drawFriend(imgCache.get(item.avatarUrl), imgCache.get(item.bgUrl), imgCache.get("ui/rank/icon_first.png"));
                    }
                } catch (err) {
                    _didIteratorError6 = true;
                    _iteratorError6 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion6 && _iterator6.return) {
                            _iterator6.return();
                        }
                    } finally {
                        if (_didIteratorError6) {
                            throw _iteratorError6;
                        }
                    }
                }
                if (this.itemMe) this.itemMe.drawFriend(imgCache.get(this.itemMe.avatarUrl), imgCache.get(this.itemMe.bgUrl), imgCache.get("ui/rank/icon_first.png"));
            }
            // 动态排行榜
                        if (this.liteRankActive) {
                //console.log("动态排行榜");
                this.ctx.clearRect(0, 0, this.sharedCanvas.width, this.sharedCanvas.height);
                // this.renderBg(0, 0, BG_WIDTH, BG_HEIGHT, 0, 0, DESIGE_WIDTH, DESIGE_HEIGHT,"ui/rank/bg_mask.png");
                                var i = 0;
                var _iteratorNormalCompletion7 = true;
                var _didIteratorError7 = false;
                var _iteratorError7 = undefined;
                try {
                    for (var _iterator7 = this.lites[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                        var lite = _step7.value;
                        lite.drawLite(imgCache.get(lite.avatarUrl), imgCache.get(lite.bgUrl));
                        this.ctx.drawImage(lite.itemCanvas, lite.x, lite.y);
                        i++;
                    }
                } catch (err) {
                    _didIteratorError7 = true;
                    _iteratorError7 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion7 && _iterator7.return) {
                            _iterator7.return();
                        }
                    } finally {
                        if (_didIteratorError7) {
                            throw _iteratorError7;
                        }
                    }
                }
            }
            // 超越好友
                        var count = this.overs ? this.overs.length : 0;
            if (this.overRankActive) {
                this.ctx.clearRect(0, 0, this.sharedCanvas.width, this.sharedCanvas.height);
                // this.ctx.drawImage(imgCache.get("ui/rank/tag_rank_over_0.png"), 200, 26);
                                if (count > 0) {
                    this.ctx.drawImage(imgCache.get("ui/rank/cell_rank_0.png"), 7, 0);
                    this.renderBg(0, 0, 130, 34, 237, 26, 130, 34, "ui/rank/tag_rank_over.png");
                    var _iteratorNormalCompletion8 = true;
                    var _didIteratorError8 = false;
                    var _iteratorError8 = undefined;
                    try {
                        for (var _iterator8 = this.overs[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
                            var over = _step8.value;
                            over.drawOver(imgCache.get(over.avatarUrl));
                            this.ctx.drawImage(over.itemCanvas, over.x, over.y);
                        }
                    } catch (err) {
                        _didIteratorError8 = true;
                        _iteratorError8 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion8 && _iterator8.return) {
                                _iterator8.return();
                            }
                        } finally {
                            if (_didIteratorError8) {
                                throw _iteratorError8;
                            }
                        }
                    }
                } else {
                    this.ctx.drawImage(imgCache.get("ui/rank/cell_rank_2.png"), 7, 0);
                    this.ctx.drawImage(imgCache.get("ui/rank/tag_rank_over_0.png"), 200, 26);
                }
            }
            //游戏中超越好友
                        if (this.loopRankActive) {
                this.ctx.clearRect(0, 0, this.sharedCanvas.width, this.sharedCanvas.height);
                var _over = this.overFriend;
                if (_over && _over.avatarUrl != this.overAvatarUrl) {
                    this.overAvatarUrl = _over.avatarUrl;
                    _over.drawLoop(imgCache.get(_over.avatarUrl), imgCache.get("ui/rank/cell_rank_0.png"), this.overRank);
                    this.ctx.drawImage(_over.itemCanvas, 0, 0);
                }
            }
        }
    }, {
        key: "startRender",
        value: function startRender() {
            var _this2 = this;
            this.stopRender();
            // 开启每帧回调
                        var fn = function fn(times) {
                if (_this2.render) {
                    _this2.render(times);
                }
                _this2._updateHandler = requestAnimationFrame(fn);
            };
            this._updateHandler = requestAnimationFrame(fn);
        }
    }, {
        key: "stopRender",
        value: function stopRender() {
            if (this._updateHandler) {
                cancelAnimationFrame(this._updateHandler);
            }
        }
    }, {
        key: "clear",
        value: function clear() {
            this.ctx.clearRect(0, 0, this.sharedCanvas.width, this.sharedCanvas.height);
        }
    }, {
        key: "scroll",
        value: function scroll(info) {
            // cocos和canvas坐标系Y轴方向相反
            // deltaY指在一次触摸事件中，据触摸初始点的Y轴变更值
            var deltaY = info.deltaY + this.startY;
            this.deltaY = Math.min(ITEM_TOP, Math.max(this.maxDeltaY, deltaY));
        }
    }, {
        key: "autoScroll",
        value: function autoScroll() {
            if (this.moveSpeed !== null) {
                this.moveRange += this.fpsDeltaTimer * this.moveSpeed;
                this.scroll({
                    deltaY: this.moveRange
                });
                if (this.moveSpeed > 0) {
                    this.moveSpeed -= SCROLL_BRAKE;
                    if (this.moveSpeed <= 0) {
                        this.moveSpeed = null;
                        this.startY = this.deltaY;
                        this.moveRange = 0;
                    }
                } else {
                    this.moveSpeed += SCROLL_BRAKE;
                    if (this.moveSpeed >= 0) {
                        this.moveSpeed = null;
                        this.startY = this.deltaY;
                        this.moveRange = 0;
                    }
                }
            }
        }
    }, {
        key: "setFpsDeltaTimer",
        value: function setFpsDeltaTimer(times) {
            if (!this.fpsStartTime) {
                this.fpsStartTime = times;
            } else {
                this.fpsDeltaTimer = times - this.fpsStartTime;
                this.fpsStartTime = times;
            }
        }
    }, {
        key: "render",
        value: function render(times) {
            this.setFpsDeltaTimer(times);
            this.autoScroll();
            this.clear();
            var i = 0;
            var _iteratorNormalCompletion9 = true;
            var _didIteratorError9 = false;
            var _iteratorError9 = undefined;
            try {
                for (var _iterator9 = this.items[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
                    var item = _step9.value;
                    item.setPosition(0 + LIST_LEFT, this.deltaY + i * (ITEM_HEIGHT + ITEM_SPACINGY) + LIST_TOP);
                    this.renderItem(item);
                    i++;
                }
            } catch (err) {
                _didIteratorError9 = true;
                _iteratorError9 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion9 && _iterator9.return) {
                        _iterator9.return();
                    }
                } finally {
                    if (_didIteratorError9) {
                        throw _iteratorError9;
                    }
                }
            }
            this.ctx.clearRect(0 + LIST_LEFT, LIST_TOP - ITEM_HEIGHT, LIST_WIDTH, ITEM_HEIGHT);
            this.ctx.clearRect(0 + LIST_LEFT, LIST_HEIGHT + LIST_TOP, LIST_WIDTH, ME_OFFSET_TOP + ITEM_HEIGHT);
            //分割线
            // this.ctx.fillStyle = "#ffffff";
            // this.ctx.fillRect(0, LIST_HEIGHT + ME_OFFSET_TOP / 2, LIST_WIDTH, 2);
                        if (this.itemMe) {
                this.itemMe.setPosition(0 + LIST_LEFT, LIST_HEIGHT + ME_OFFSET_TOP + LIST_TOP);
                this.renderItem(this.itemMe);
            }
        }
    }, {
        key: "renderBg",
        value: function renderBg(clipX, clipY, clipW, clipH, posX, posY, displayW, displayH, bgUrl) {
            if (imgCache.get(bgUrl)) this.ctx.drawImage(imgCache.get(bgUrl), clipX, clipY, clipW, clipH, posX, posY, displayW ? displayW : clipW, displayH ? displayH : clipH);
        }
    }, {
        key: "renderItem",
        value: function renderItem(item) {
            if (!this.isItemVisible(item)) {
                return;
            }
            this.ctx.drawImage(item.itemCanvas, item.x, item.y);
        }
    }, {
        key: "isItemVisible",
        value: function isItemVisible(item) {
            if (!item.rendered) {
                return false;
            }
            // if (item.y >= this.sharedCanvas.height || item.y <= -ITEM_HEIGHT) {
                        if (item.y < LIST_TOP - ITEM_HEIGHT || item.y > LIST_HEIGHT + ME_OFFSET_TOP + LIST_TOP) {
                return false;
            } else {
                return true;
            }
        }
        //等待所有资源就绪，先加载背景，再加载头像
        }, {
        key: "loadImg",
        value: function loadImg() {
            var self = this;
            self.userAvatar.push.apply(self.userAvatar, ITEM_BG_PATH);
            Promise.all(self.userAvatar.map(function(path) {
                return self.imgReadyPromise(path);
            })).then(function(urls) {
                return self.drawItem(urls);
            }).catch(function(err) {
                return console.error("load img fault. ", err);
            });
        }
    }, {
        key: "imgReadyPromise",
        value: function imgReadyPromise(imgUrl) {
            return new Promise(function(resolve, reject) {
                var iurl = imgUrl;
                if (!imgUrl.startsWith("http")) {
                    iurl = RES_DIR + iurl;
                }
                if (imgCache.get(imgUrl)) {
                    resolve(imgUrl);
                    return;
                }
                var img = wx.createImage();
                img.src = iurl;
                img.onload = function() {
                    resolve(imgUrl);
                };
                img.onerror = function() {
                    reject(iurl + " 加载失败");
                };
                // 想了一下，还是在这里cache，不希望创建多个img，加载url失败了就let it crash吧
                                imgCache.put(imgUrl, img);
            });
        }
    }, {
        key: "refreshScroe",
        value: function refreshScroe(score) {
            var self = this;
            // if (score > self.userScore) {
            //更新历史最高积分
                        self.userScore = score;
            wx.setUserCloudStorage({
                KVDataList: [ {
                    key: "score",
                    value: score + ""
                } ],
                success: function success(res) {
                    //console.log("refresh score finished.");
                    self.refreshRank();
                },
                fail: function fail(res) {
                    console.error("refresh score fault, for wechat opdata.");
                }
            });
            // } else {
            //     self.refreshRank();
            // }
                }
    } ]);
    return RankListRenderer;
}();

var renderer = new RankListRenderer();

renderer.listen();