var _createClass = function() {
    function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) descriptor.writable = true;
            Object.defineProperty(target, descriptor.key, descriptor);
        }
    }
    return function(Constructor, protoProps, staticProps) {
        if (protoProps) defineProperties(Constructor.prototype, protoProps);
        if (staticProps) defineProperties(Constructor, staticProps);
        return Constructor;
    };
}();

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}

var Item = function() {
    /**
     * @param {Object} info 显示的信息
     */
    function Item(info, w, h) {
        _classCallCheck(this, Item);
        this.itemCanvas = wx.createCanvas();
        this.itemCanvas.width = w;
        this.itemCanvas.height = h;
        this.ctx = this.itemCanvas.getContext("2d");
        this.ctx.baseLine = "middle";
        this.ctx.imageSmoothingEnabled = true;
        this.ctx.imageSmoothingQuality = "high";
        this.avatarUrl = info.avatarUrl;
        this.bgUrl = info.bgUrl;
        this.info = info;
        this.rendered = false;
    }
    _createClass(Item, [ {
        key: "setInfo",
        value: function setInfo(info) {
            this.avatarUrl = info.avatarUrl;
            this.bgUrl = info.bgUrl;
            this.info = info;
        }
    }, {
        key: "destroy",
        value: function destroy() {
            this.itemCanvas = null;
        }
    }, {
        key: "drawFriend",
        value: function drawFriend(avatarImg, bgImg) {
            var firstImg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
            this.clear();
            this.ctx.drawImage(bgImg, 0, 0, this.itemCanvas.width, this.itemCanvas.height);
            this.ctx.drawImage(avatarImg, 80, 7, 68, 68);
            var name = this.info.nickName.length > 6 ? this.info.nickName.substr(0, 8) : this.info.nickName;
            this.drawText(name, 181, 30, 26, "#000000", "left");
            this.drawText(this.info.score, 537, 27, 26, "#000000", "right");
            var rank = this.info.rank + 1;
            if (rank == 1 && firstImg) {
                this.ctx.drawImage(firstImg, 11, 11, 51, 61);
            } else {
                if (rank == 0) {
                    rank = "未上榜";
                    // this.drawText(rank, 38, 31, 28, "#000000", "center", "bold");
                                        this.drawText(rank, 38, 29, 24, "#9f605f", "center");
                } else {
                    this.drawText(rank, 38, 29, 32, "#9f605f", "center");
                }
            }
            this.rendered = true;
        }
    }, {
        key: "drawLite",
        value: function drawLite(avatarImg, bgImg) {
            this.clear();
            // this.ctx.drawImage(bgImg, 0, 0, 180, 454);
            // let name = this.info.nickName.length > 6 ? this.info.nickName.substr(0, 6) : this.info.nickName;
                        this.ctx.drawImage(avatarImg, 33, 42, 112, 112);
            this.drawText(this.info.rank + 1, 90, 0, 30, "#ffffff", "center", "bold");
            //this.drawText(name, 90, 283, 32, "#ffffff", "center");
                        this.drawText(this.info.score, 90, 166, 31, "#ffffff", "center");
            this.rendered = true;
            // let _bg_height = 0;
            // let _bg_width = 0;
            // let _avatar_height = 112;
            // let _avatar_width = 112;
            // let _avatar_left = 34;
            // let _avatar_top = 149;
            // let _rank_text_size = 50;
            // let _rank_text_left = 90;
            // let _rank_text_top = 86;
            // let _name_text_size = 32;
            // let _name_text_left = 90;
            // let _name_text_top = 283;
            // let _score_text_size = 32;
            // let _score_text_left = 90;
            // let _score_text_top = 336;
                }
    }, {
        key: "drawOver",
        value: function drawOver(avatarImg) {
            this.clear();
            this.ctx.drawImage(avatarImg, 0, 0, this.itemCanvas.width, this.itemCanvas.height);
            this.rendered = true;
        }
        //游戏中动态排行
        }, {
        key: "drawLoop",
        value: function drawLoop(avatarImg, bgImg, rank) {
            this.clear();
            if (rank == -1) {
                // this.drawText("加油哦，你可以玩的更好！", 335, 41, 39, "#ffffff", "center");
                return;
            }
            this.ctx.fillStyle = "#ffffff";
            this.ctx.fillRect(0, 0, 242, 60);
            this.ctx.drawImage(bgImg, 0, 0, 242, 60);
            this.ctx.drawImage(avatarImg, 182, 0, 60, 60);
            this.rendered = true;
        }
    }, {
        key: "clear",
        value: function clear() {
            this.ctx.clearRect(0, 0, this.itemCanvas.width, this.itemCanvas.height);
        }
    }, {
        key: "drawText",
        value: function drawText(text, x, y, fontSize, color, align, weight) {
            var _weight = weight ? weight : "normal";
            this.ctx.textBaseline = "hanging";
            this.ctx.font = _weight + " " + fontSize + "px Microsoft YaHei";
            this.ctx.fillStyle = color || "#ffffff";
            this.ctx.textAlign = align || "left";
            this.ctx.fillText(text, x, y, 750);
        }
    }, {
        key: "setPosition",
        value: function setPosition(x, y) {
            this.x = x;
            this.y = y;
        }
    } ]);
    return Item;
}();

module.exports = Item;